﻿Ext.require('App.Const.Finances');
Ext.define('App.View.Kivii.Finances.Payment.Filter.List2', {
    extend: 'System.Control.EntityList',
    entityType: 'Kivii.Finances.Entities.Payment',
    xtype: 'App.View.Kivii.Finances.Payment.Filter.List2',
    dataSource: '/Restful/Kivii.Finances.Entities.Payment/QueryEx.json',
    requires: ['App.Control.DownloadField','System.Control.ComboSelector'],
    title: '到账认领(管理)',
    iconCls: 'x-fa fa-filter',
    filter: {
        // OwnerType:"Department",
        IsPayee: true,
        IsSplit: false
        // OperateTimeGreaterThanOrEqualTo: new Date(new Date().getFullYear(), new Date().getMonth(), 1),
        // OperateTimeLessThan: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate() + 1)
    },
    //在末尾保留足够的滚动条大小的控件
    reserveScrollbar: true,
    //默认情况下启用缓冲渲染
    //启用缓存会造成空白行的问题,有些数据过多会预留渲染控件,切换成数据少的会预留空白
    bufferedRenderer: false,
    viewModel: {
        data: {
            _selection: null
        }
    },
    bind: {
        selection: '{_selection}'
    },
    store: {
        autoLoad: true,
        pageSize: 400,
        sorters: [{
            property: 'OperateTime',
            direction: 'desc'
        }]
    },
    selModel: {
        selType: 'checkboxmodel',
        checkboxSelect: true,
        pruneRemoved: false,
        extensible: 'y'
    },
    features: [{
        ftype: 'summary'
    }],
    dockedItems: [{
        xtype: 'pagingtoolbar',
        dock: 'bottom',
        displayInfo: true,
        items: [{
            xtype: 'button',
            labelWidth: 60,
            iconCls: 'x-fa fa-check-square-o',
            bind: {
                text: '已选择{selectionCount}条记录,点击清除',
                hidden: '{selectionCount==0}'
            },
            handler: '_onClearSelections'
        }]
    }, {
        xtype: 'toolbar',
        dock: 'top',
        overflowHandler: 'scroller',
        items: [{
                xtype: 'combo',
                queryMode: 'local',
                displayField: 'displayInfo',
                valueField: 'isSplit',
                value: false,
                editable: false,
                filterPickList: true,
                reference: 'isSplit',
                store: {
                    fields: ['displayInfo', 'isSplit'],
                    data: [{
                        displayInfo: '已认领',
                        isSplit: true
                    }, {
                        displayInfo: '未认领',
                        isSplit: false
                    }]
                },
                triggers: {
                    clear: {
                        weight: 2,
                        cls: 'x-fa fa-times',
                        handler: '_cleanIsSplit'
                    }
                },
                listeners: {
                    select: '_onSelectIsSplit'
                }
            }, {
                xtype: 'datefield',
                fieldLabel: '时间范围  开始',
                format: 'Y-m-d',
                labelWidth: 90,
                reference: 'startTime',
                triggers: {
                    clear: {
                        weight: 2,
                        cls: 'x-fa fa-times',
                        handler: '_cleanBeginOperateTime'
                    }
                },
                editable: false,
                // value: new Date(new Date().getFullYear(), new Date().getMonth(), 1),
                listeners: {
                    select: '_onSelectMonth'
                }
            },
            {
                xtype: 'datefield',
                fieldLabel: '结束',
                format: 'Y-m-d',
                labelWidth: 30,
                reference: 'endTime',
                // value: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate() + 1),
                editable: false,
                triggers: {
                    clear: {
                        weight: 2,
                        cls: 'x-fa fa-times',
                        handler: '_cleanEndOperateTime'
                    }
                },
                // value: new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate() + 1),
                listeners: {
                    select: '_onSelectMonth'
                }
            }, {
                xtype: 'searchField',
                flex: 1,
                minWidth: 250,
                labelWidth: 60,
                queryField: 'SerialNumber,PayerName,PayeeName',
                emptyText: '模糊搜索流水号、付款单位、收款单位',
            }, {
                xtype: 'splitbutton',
                text: '认领',
                iconCls: 'x-fa fa-arrow-circle-down',
                type: 'Split',
                handler: '_onSplit',
                menu: [{
                    text: '退款处理',
                    iconCls: 'x-fa fa-reply',
                    type: 'Refund',
                    handler: '_onSplit'
                }, {
                    text: '非业务处理',
                    iconCls: 'x-fa fa-eraser',
                    type: 'UnBiz',
                    handler: '_onSplit'
                }],
                bind: {
                    disabled: '{!_selection}'
                }
            }, {
                xtype: 'splitbutton',
                text: '认领记录',
                iconCls: 'x-fa fa-spinner',
                handler: '_onSplitList',
                menu: [{
                    text: '开票记录',
                    iconCls: 'x-fa fa-money',
                    type: 'Refund',
                    handler: '_onInvoiceList'
                }],
                bind: {
                    disabled: '{!_selection}'
                }
            }, {
                xtype: 'downloadField',
                dataSource: '/Restful/Kivii.Finances.Entities.Payment/QueryEx.xlsx', //数据源
                fileName: '数据导出',
                window: {
                    type: 'App.Control.Kivii.Finances.General.Template.Selector',
                    title: '选择模板',
                    iconCls: 'x-fa fa-file-excel-o',
                    autoScroll: true,
                    width: 700,
                    height: 350,
                    closeAction: 'hide',
                    modal: true,
                    layout: 'fit',
                    filter: {
                        FolderPath: '/Finances/Payment/Files',
                        TagsContains: 'QueryEx'
                    }
                }
            }
        ]
    }],
    columns: {
        defaults: {
            menuDisabled: true,
            sortable: true
        },
        items: [{
            xtype: 'rownumberer',
            align: 'center',
            resizable: false
        }, {
            text: '流水号',
            dataIndex: 'SerialNumber',
            width: 120
        }, {
            text: '所属范围',
            dataIndex: 'OwnerName',
            width: 120
        }, {
            text: '付款单位',
            dataIndex: 'PayerName',
            summaryType: 'sum',
            summaryRenderer: function(value, summaryData, dataIndex) {
                return '合计 ￥';
            },
            width: 220
        }, {
            text: '到账金额',
            align: 'right',
            dataIndex: 'Amount',
            renderer: KiviiContext.Const.FinancesFunctionsMoneyToFmoney,
            summaryType: 'sum',
            summaryRenderer: function(value, summaryData, dataIndex) {
                return Ext.String.format('{0}', value.toFixed(2));
            },
            width: 110
        }, {
            text: '已认领',
            align: 'right',
            dataIndex: 'AmountSplited',
            renderer: '_renderAmount',
            summaryType: 'sum',
            summaryRenderer: function(value, summaryData, dataIndex) {
                return Ext.String.format('{0}', value.toFixed(2));
            },
            width: 90
        }, {
            text: '开票金额',
            align: 'right',
            dataIndex: 'AmountInvoice',
            renderer: '_renderAmount',
            summaryType: 'sum',
            summaryRenderer: function(value, summaryData, dataIndex) {
                return Ext.String.format('{0}', value.toFixed(2));
            },
            width: 100
        }, {
            text: '已用金额',
            align: 'right',
            dataIndex: 'AmountUsed',
            renderer: '_renderAmount',
            summaryType: 'sum',
            summaryRenderer: function(value, summaryData, dataIndex) {
                return Ext.String.format('{0}', value.toFixed(2));
            },
            width: 100
        }, {
            text: '收款单位',
            dataIndex: 'PayeeName',
            renderer: '_renderPayee',
            width: 220
        }, {
            xtype: 'datecolumn',
            text: '发生日期',
            format: 'Y-m-d H:i',
            dataIndex: 'OperateTime',
            width: 150
        }, {
            text: '付款类型',
            dataIndex: 'Type',
            renderer: '_renderType',
            width: 100
            // }, {
            //     text: '操作人',
            //     dataIndex: 'OperatorName',
            //     width: 100
        }, {
            text: '摘要',
            dataIndex: 'Summary',
            width: 150
        }, {
            text: '付款银行',
            dataIndex: 'PayerAccountName',
            width: 280
        }, {
            text: '付款账号',
            dataIndex: 'PayerAccountSerialNumber',
            width: 180
        }, {
            text: '备注',
            dataIndex: 'Remark',
            minWidth: 150,
            flex: 1
        }]
    },
    listeners: {
        activate: '_onActivate'
    },
    controller: {
        _onClearSelections: function() {
            this.getView().clearSelections();
        },
        _onActivate: function(_ctrl, _eOpts) {
            this.getView().reload();
        },
        _renderAmount: function(_value, _meta, _record, _rowIndex) {
            if (_value === _record.data.Amount) {
                _meta.style = 'background-color:#B4EEB4';
            }
            return KiviiContext.Const.FinancesFunctionsMoneyToFmoney(_value);
        },
        _renderType: function(_value, _meta, _record, _rowIndex) {
            if (_value === 'Cash') {
                return '现金';
            }
            if (_value === 'Pos') {
                return '刷卡';
            }
            if (_value === 'AliPay') {
                return '支付宝';
            }
            if (_value === 'WeChat') {
                return '微信';
            }
            if (_value === 'Bank') {
                return '银行转账';
            }
            return _value;
        },
        _renderPayee: function(_value, _meta, _record, _rowIndex) {
            if (_value !== KiviiContext.CurrentMember.OrganizationName) {
                _meta.style = 'background-color:#FFE4C4';
            }
            return _value;
        },

        _cleanBeginOperateTime: function(_ctrl) {
            _ctrl.setValue(null);
            let _me = this;
            let _view = _me.getView();
            if (_view.filter === null) _view.setFilter({});
            delete _view.filter.OperateTimeGreaterThanOrEqualTo;
            _view.reload();
        },
        _cleanEndOperateTime: function(_ctrl) {
            _ctrl.setValue(null);
            let _me = this;
            let _view = _me.getView();
            if (_view.filter === null) _view.setFilter({});
            delete _view.filter.OperateTimeLessThan;
            _view.reload();
        },
        _onSelectMonth: function(_ctrl, _time, _eOpts) {
            let _controller = this;
            let _view = _controller.getView();
            let _refs = _controller.getReferences();
            let _startTime = _refs.startTime.value;
            let _endTime = _refs.endTime.value || new Date();
            if (_startTime === null) {
                Ext.toast("请选择开始时间!");
                return;
            }
            if (_startTime > _endTime) {
                Ext.toast("开始日期不能大于结束日期!");
                return;
            }
            delete _view.filter.OperateTimeGreaterThanOrEqualTo;
            delete _view.filter.OperateTimeLessThan;
            _view.filter.OperateTimeGreaterThanOrEqualTo = new Date(_startTime.getFullYear(), _startTime.getMonth(), _startTime.getDate());
            _view.filter.OperateTimeLessThan = new Date(_endTime.getFullYear(), _endTime.getMonth(), _endTime.getDate() + 1);
            _view.reload();
        },
        _selectDepart: function(_ctrl, _record, _eOpts) {
            let _controller = this;
            let _view = _controller.getView();
            _view.filter.OwnerKvid = _record.data.DepartmentKvid;
            _view.reload();
        },
        _cleanDepart: function(_ctrl) {
            _ctrl.setValue('');
            let _controller = this;
            let _view = _controller.getView();
            if (_view.filter === null) _view.setFilter({});
            delete _view.filter.OwnerKvid;
            _view.reload();
        },
        _onSelectIsSplit: function(_ctrl, _record) {
            let _controller = this;
            let _view = _controller.getView();
            _view.filter.IsSplit = _record.data.isSplit;
            _view.reload();
        },
        _cleanIsSplit: function(_ctrl) {
            _ctrl.setValue('');
            let _controller = this;
            let _view = _controller.getView();
            if (_view.filter === null) _view.setFilter({});
            _view.filter.IsSplit = null;
            _view.reload();
        },
        _onSplit: function(_ctrl) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            let _selecteds = _vm.data.selections || [];
            if (!_view.selection) return;
            if (_selecteds.length <= 0) return;
            let _form = Ext.create('App.Control.Kivii.Finances.Payment.Filter.Form');
            let _win = Ext.create('Ext.window.Window', {
                layout: 'fit',
                title: _ctrl.text,
                iconCls: _ctrl.iconCls,
                iconAlign: 'left',
                autoScroll: true,
                width: 450,
                height: 200,
                modal: true,
                resizable: false,
                items: [_form]
            });
            _form.setOwner(_selecteds, _ctrl);
            _win.show();
            _form.on('entitySplited', function(_ctrl, _entity) {
                _win.close();
                _view.reload();
            });
        },
        _onInvoiceList: function(_ctrl) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            let _selecteds = _vm.data.selections || [];
            if (!_view.selection) return;
            if (_selecteds.length !== 1) {
                Ext.toast("请选择一条到账查看开票记录!");
                return;
            }
            let _form = Ext.create('App.Control.Kivii.Finances.Invoice.Payed.List', {
                header: false
            });
            let _win = Ext.create('Ext.window.Window', {
                layout: 'fit',
                title: _ctrl.text,
                iconCls: _ctrl.iconCls,
                iconAlign: 'left',
                // header:false,
                autoScroll: true,
                width: 1200,
                height: 650,
                modal: true,
                maximizable: true,
                resizable: true,
                items: [_form]
            });
            _form.setFilter({
                // OwnerKvid: KiviiContext.CurrentMember.DepartmentKvid,
                BizKvid: _view.selection.data.RootKvid
            });
            _win.show();
            // _win.on('close', function(_ctrl, _entity) {
            //     _view.reload();
            // });
        },
        _onSplitList: function(_ctrl) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            let _selecteds = _vm.data.selections || [];
            if (!_view.selection) return;
            if (_selecteds.length !== 1) {
                Ext.toast("请选择一条到账查看认领记录!");
                return;
            }
            let _form = Ext.create('App.View.Kivii.Finances.Payment.Split.List', {
                header: false
            });
            let _win = Ext.create('Ext.window.Window', {
                layout: 'fit',
                title: _ctrl.text,
                iconCls: _ctrl.iconCls,
                iconAlign: 'left',
                // header:false,
                autoScroll: true,
                width: 1200,
                height: 650,
                modal: true,
                maximizable: true,
                resizable: true,
                items: [_form]
            });
            _form.setFilter({
                // OwnerType:"Department",
                ParentKvid: _view.selection.data.Kvid
            });
            _win.show();
            // _win.on('close', function(_ctrl, _entity) {
            //     _view.reload();
            // });
        }
    }
});